<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__scb__i2c" kind="group">
    <compoundname>group_scb_i2c</compoundname>
    <title>I2C (SCB)</title>
    <innergroup refid="group__group__scb__i2c__macros">Macros</innergroup>
    <innergroup refid="group__group__scb__i2c__functions">Functions</innergroup>
    <innergroup refid="group__group__scb__i2c__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__scb__i2c__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>Driver API for I2C Bus Peripheral. </para>    </briefdescription>
    <detaileddescription>
<para>I2C - The Inter-Integrated Circuit (I2C) bus is an industry-standard.</para><para>The functions and other declarations used in this part of the driver are in cy_scb_i2c.h. You can also include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The I2C peripheral driver provides an API to implement I2C slave, master, or master-slave devices based on the SCB hardware block. I2C devices based on SCB hardware are compatible with I2C Standard-mode, Fast-mode, and Fast-mode Plus specifications as defined in the I2C-bus specification.</para><para>Features:<itemizedlist>
<listitem><para>An industry-standard I2C bus interface</para></listitem><listitem><para>Supports slave, master, and master-slave operation</para></listitem><listitem><para>Supports standard data rates of 100/400/1000 kbps</para></listitem><listitem><para>Hardware Address Match, multiple addresses</para></listitem><listitem><para>Wake from Deep Sleep on Address Match</para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>The I2C driver configuration can be divided to number of sequential steps listed below:<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_config">Configure I2C</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_pins">Assign and Configure Pins</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_clock">Assign Clock Divider</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_data_rate">Configure Data Rate</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_intr">Configure Interrupt</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_enable">Enable I2C</ref></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;I2C driver is built on top of the SCB hardware block. The SCB3 instance is used as an example for all code snippets. Modify the code to match your design.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Configure I2C</bold></para>
<para>To set up the I2C driver, provide the configuration parameters in the <ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref> structure. Provide i2cMode to the select operation mode slave, master or master-slave. The useRxFifo and useTxFifo parameters specify if RX and TX FIFO is used during operation. Typically, both FIFOs should be enabled to reduce possibility of clock stringing. However, using RX FIFO has side effects that needs to be taken into account (see useRxFifo field description in <ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref> structure). For master modes, parameters lowPhaseDutyCycle, highPhaseDutyCycle and enableDigitalFilter can be used to define output data rate (refer to section <ref kindref="member" refid="group__group__scb__i2c_1group_scb_i2c_data_rate">Configure Data Rate</ref> for more information). For slave mode, provide the slaveAddress and slaveAddressMask. The other parameters are optional for operation.<linebreak />
To initialize the driver, call <ref kindref="member" refid="group__group__scb__i2c__general__functions_1ga91fbfb16a78c014fd88681b83544c2f7">Cy_SCB_I2C_Init</ref> function providing a pointer to the populated <ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref> structure and the allocated <ref kindref="compound" refid="structcy__stc__scb__i2c__context__t">cy_stc_scb_i2c_context_t</ref> structure.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />context<sp />for<sp />I2C<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__scb__i2c__context__t">cy_stc_scb_i2c_context_t</ref><sp />i2cContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(USE_I2C_SLAVE)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Slave<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref><sp />i2cConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__scb__i2c__config__t_1ab317c1252433320bfd76d2b8629dac23">i2cMode</ref><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga848386100a4d9700bf5bb790b3db3ed2a9ceefa04abbb537720c9924350b5e179">CY_SCB_I2C_SLAVE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.useRxFifo<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.useTxFifo<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.slaveAddress<sp /><sp /><sp /><sp /><sp />=<sp />0x08U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.slaveAddressMask<sp />=<sp />0xFEU,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.acceptAddrInFifo<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.ackGeneralAddr<sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableWakeFromSleep<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableDigitalFilter<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.lowPhaseDutyCycle<sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.highPhaseDutyCycle<sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else<sp /></highlight><highlight class="comment">/*<sp />USE_I2C_MASTER<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Master<sp /><sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref><sp />i2cConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__scb__i2c__config__t_1ab317c1252433320bfd76d2b8629dac23">i2cMode</ref><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga848386100a4d9700bf5bb790b3db3ed2ac1dc09a53d6852a737909498356978c6">CY_SCB_I2C_MASTER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.useRxFifo<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.useTxFifo<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.slaveAddress<sp /><sp /><sp /><sp /><sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.slaveAddressMask<sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.acceptAddrInFifo<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.ackGeneralAddr<sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableWakeFromSleep<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableDigitalFilter<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.lowPhaseDutyCycle<sp />=<sp />8U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.highPhaseDutyCycle<sp />=<sp />8U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />I2C<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__i2c__general__functions_1ga91fbfb16a78c014fd88681b83544c2f7">Cy_SCB_I2C_Init</ref>(SCB3,<sp />&amp;i2cConfig,<sp />&amp;i2cContext);</highlight></codeline>
</programlisting> Set up I2C slave read and write buffer before enabling its operation using <ref kindref="member" refid="group__group__scb__i2c__slave__functions_1ga179b4495d7255567bb8b166e16e5a073">Cy_SCB_I2C_SlaveConfigReadBuf</ref> and <ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gaaf2d216e9cb246dd2256521cb7f50170">Cy_SCB_I2C_SlaveConfigWriteBuf</ref> appropriately. Note that the master reads data from the slave read buffer and writes data into the slave write buffer.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />buffers<sp />for<sp />I2C<sp />slave<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />BUFFER_SIZE<sp />(128UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint8_t<sp />i2cReadBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal">uint8_t<sp />i2cWriteBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />write<sp />and<sp />read<sp />buffers<sp />for<sp />communication<sp />with<sp />master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1ga179b4495d7255567bb8b166e16e5a073">Cy_SCB_I2C_SlaveConfigReadBuf</ref><sp />(SCB3,<sp />i2cReadBuffer,<sp /><sp />BUFFER_SIZE,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gaaf2d216e9cb246dd2256521cb7f50170">Cy_SCB_I2C_SlaveConfigWriteBuf</ref>(SCB3,<sp />i2cWriteBuffer,<sp />BUFFER_SIZE,<sp />&amp;i2cContext);</highlight></codeline>
</programlisting></para>

<para><bold>Assign and Configure Pins</bold></para>
<para>Only dedicated SCB pins can be used for I2C operation. The HSIOM register must be configured to connect dedicated SCB I2C pins to the SCB block. Also the I2C pins must be configured in Open-Drain, Drives Low mode (this pins configuration implies usage of external pull-up resistors):</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />pins<sp />for<sp />I2C<sp />on<sp />SCB3:<sp />P6[0]<sp />and<sp />P6[1]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_PORT<sp /><sp /><sp /><sp /><sp /><sp />(P6_0_PORT)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_SCL_NUM<sp /><sp /><sp />(P6_0_NUM)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_SDA_NUM<sp /><sp /><sp />(P6_1_NUM)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />SCB3<sp />I2C<sp />function<sp />to<sp />pins<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(I2C_PORT,<sp />I2C_SCL_NUM,<sp />P6_0_SCB3_I2C_SCL);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(I2C_PORT,<sp />I2C_SDA_NUM,<sp />P6_1_SCB3_I2C_SDA);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />pins<sp />for<sp />I2C<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(I2C_PORT,<sp />I2C_SCL_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1ga4c713a8cb3c1e444153829c5ea94b34f">CY_GPIO_DM_OD_DRIVESLOW</ref>);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(I2C_PORT,<sp />I2C_SDA_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1ga4c713a8cb3c1e444153829c5ea94b34f">CY_GPIO_DM_OD_DRIVESLOW</ref>);</highlight></codeline>
</programlisting> <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The alternative pins configuration is Resistive Pull-ups which implies usage internal pull-up resistors. This configuration is not recommended because resistor value is fixed and cannot be used for all supported data rates. Refer to the device datasheet parameter RPULLUP for resistor value specifications.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Assign Clock Divider</bold></para>
<para>A clock source must be connected to the SCB block to oversample input and output signals, in this document this clock will be referred as clk_scb. You must use one of the 8-bit or 16-bit dividers. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do this.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />divider<sp />type<sp />and<sp />number<sp />for<sp />I2C<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_CLK_DIV_TYPE<sp /><sp />(CY_SYSCLK_DIV_8_BIT)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_CLK_DIV_NUM<sp /><sp /><sp />(0U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />assigned<sp />divider<sp />to<sp />be<sp />a<sp />clock<sp />source<sp />for<sp />I2C<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gacb66324e3191006f6d1cee8b29238fb2">Cy_SysClk_PeriphAssignDivider</ref>(PCLK_SCB3_CLOCK,<sp />I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUM);</highlight></codeline>
</programlisting></para>

<para><bold>Configure Data Rate</bold></para>
<para>To get I2C slave operation with the desired data rate, the clk_scb must be fast enough to provide sufficient oversampling. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do this.</para><para><programlisting><codeline><highlight class="comment">/*<sp />I2C<sp />slave<sp />desired<sp />data<sp />rate<sp />is<sp />400<sp />kbps.</highlight></codeline>
<codeline><highlight class="comment">*<sp />To<sp />support<sp />this<sp />data<sp />rate<sp />the<sp />clk_scb<sp />frequency<sp />must<sp />be<sp />in<sp />range<sp />7.82<sp />–<sp />15.38<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />Find<sp />clk_scb<sp />valid<sp />ranges<sp />in<sp />TRM<sp />section<sp />I2C<sp />sub-section<sp />Oversampling<sp />and<sp />Bit<sp />Rate.</highlight></codeline>
<codeline><highlight class="comment">*<sp />For<sp />clk_peri<sp />=<sp />50<sp />MHz,<sp />select<sp />divider<sp />value<sp />4<sp />and<sp />get<sp />clk_scb<sp />=<sp />(50<sp />MHz<sp />/<sp />4)<sp />=<sp />12.5<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />This<sp />clock<sp />frequency<sp />meets<sp />requirements<sp />above.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref><sp /><sp /><sp />(I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUMBER,<sp />3u);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUMBER);</highlight></codeline>
</programlisting> To get I2C master operation with the desired data rate, the source clock frequency and SCL low and high phase duration must be configured. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to configure source clock frequency. Then call <ref kindref="member" refid="group__group__scb__i2c__general__functions_1gae9d71372b84c9c799b55283fc475f223">Cy_SCB_I2C_SetDataRate</ref> to set the SCL low, high phase duration and digital filter. This function sets SCL low and high phase settings based on source clock frequency.</para><para><programlisting><codeline><highlight class="normal">uint32_t<sp />dataRate;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />I2C<sp />master<sp />desired<sp />data<sp />rate<sp />in<sp />Hz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_DESIRED_DATA_RATE_HZ<sp /><sp /><sp /><sp />(100000U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />I2C<sp />master<sp />desired<sp />data<sp />rate<sp />is<sp />100<sp />kbps.</highlight></codeline>
<codeline><highlight class="comment">*<sp />To<sp />support<sp />this<sp />data<sp />rate<sp />the<sp />clk_scb<sp />frequency<sp />must<sp />be<sp />in<sp />range<sp />1.55<sp />–<sp />3.2<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />Find<sp />clk_scb<sp />valid<sp />ranges<sp />in<sp />TRM<sp />section<sp />I2C<sp />sub-section<sp />Oversampling<sp />and<sp />Bit<sp />Rate.</highlight></codeline>
<codeline><highlight class="comment">*<sp />For<sp />clk_peri<sp />=<sp />50<sp />MHz,<sp />select<sp />divider<sp />value<sp />32<sp />and<sp />get<sp />clk_scb<sp />=<sp />(50<sp />MHz<sp />/<sp />32)<sp />=<sp />1.563<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />This<sp />clock<sp />frequency<sp />meets<sp />requirements<sp />above.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref><sp /><sp /><sp />(I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUMBER,<sp />31u);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUMBER);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />master<sp />to<sp />operate<sp />with<sp />desired<sp />data<sp />rate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">dataRate<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__general__functions_1gae9d71372b84c9c799b55283fc475f223">Cy_SCB_I2C_SetDataRate</ref>(SCB3,<sp />I2C_DESIRED_DATA_RATE_HZ,<sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga366428a7c17da00f7a7ae025aeda2e23">Cy_SysClk_PeriphGetFrequency</ref>(I2C_CLK_DIV_TYPE,<sp />I2C_CLK_DIV_NUMBER));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((dataRate<sp />&gt;<sp />I2C_DESIRED_DATA_RATE_HZ)<sp />||<sp />(dataRate<sp />==<sp />0U))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Can<sp />not<sp />reach<sp />desired<sp />data<sp />rate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(0U);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> Alternatively, the low, high phase and digital filter can be set directly using configuration structure <ref kindref="compound" refid="structcy__stc__scb__i2c__config__t">cy_stc_scb_i2c_config_t</ref> fields lowPhaseDutyCycle, highPhaseDutyCycle and enableDigitalFilter appropriately.<linebreak />
<bold>Refer to the technical reference manual (TRM) section I2C sub-section Oversampling and Bit Rate to get information how to configure I2C to run with the desired data rate.</bold></para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;For I2C slave, the analog filter is used for all supported data rates. &lt;br /&gt;For I2C master, the analog filter is used for Standard and Fast modes and the digital filter for Fast Plus mode.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Configure Interrupt</bold></para>
<para>The interrupt is mandatory for I2C operation. The exception is the when only the <ref kindref="compound" refid="group__group__scb__i2c__master__low__level__functions">Master Low-Level</ref> functions are used. The driver provides three interrupt functions: <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref>, <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga87512a96b0ae32bb624a5a960d64d23f">Cy_SCB_I2C_SlaveInterrupt</ref>, and <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga3133d46624010df1c57a0800797aab01">Cy_SCB_I2C_MasterInterrupt</ref>. One of these functions must be called in the interrupt handler for the selected SCB instance. Call <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga87512a96b0ae32bb624a5a960d64d23f">Cy_SCB_I2C_SlaveInterrupt</ref> when I2C is configured to operate as a slave, <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga3133d46624010df1c57a0800797aab01">Cy_SCB_I2C_MasterInterrupt</ref> when I2C is configured to operate as a master and <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref> when I2C is configured to operate as master and slave. Using the slave- or master-specific interrupt function allows reducing the flash consumed by the I2C driver. Also this interrupt must be enabled in the NVIC otherwise it will not work. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The I2C driver documentation refers to the &lt;a href="group__group__scb__i2c__interrupt__functions.html#group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24"&gt;Cy_SCB_I2C_Interrupt&lt;/a&gt; function when interrupt processing is mandatory for the operation. This is done to simplify the readability of the driver's documentation. The application should call the slave- or master-specific interrupt functions &lt;a href="group__group__scb__i2c__interrupt__functions.html#group__group__scb__i2c__interrupt__functions_1ga87512a96b0ae32bb624a5a960d64d23f"&gt;Cy_SCB_I2C_SlaveInterrupt&lt;/a&gt; or &lt;a href="group__group__scb__i2c__interrupt__functions.html#group__group__scb__i2c__interrupt__functions_1ga3133d46624010df1c57a0800797aab01"&gt;Cy_SCB_I2C_MasterInterrupt&lt;/a&gt;, when appropriate.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />I2C_Isr(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref>(SCB3,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />I2C<sp />interrupt<sp />number<sp />and<sp />priority<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_INTR_NUM<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />scb_3_interrupt_IRQn</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />I2C_INTR_PRIORITY<sp /><sp /><sp />(7UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />(code<sp />specific<sp />for<sp />CM4)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />i2cIntrConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp /><sp /><sp /><sp /><sp /><sp />=<sp />I2C_INTR_NUM,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />I2C_INTR_PRIORITY,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Hook<sp />interrupt<sp />service<sp />routine<sp />and<sp />enable<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;i2cIntrConfig,<sp />&amp;I2C_Isr);</highlight></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ(I2C_INTR_NUM);</highlight></codeline>
</programlisting></para>

<para><bold>Enable I2C</bold></para>
<para>Finally, enable the I2C operation by calling <ref kindref="member" refid="group__group__scb__i2c__general__functions_1gad14d83faab69d2ac96feede664df3687">Cy_SCB_I2C_Enable</ref>. Then I2C slave starts respond to the assigned address and I2C master ready to execute transfers.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Enable<sp />I2C<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__general__functions_1gad14d83faab69d2ac96feede664df3687">Cy_SCB_I2C_Enable</ref>(SCB3);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">__enable_irq();</highlight></codeline>
</programlisting> </para>


<para><heading level="1">Common Use Cases</heading></para>

<para><bold>Master Operation</bold></para>
<para>The master API is divided into two categories: <ref kindref="compound" refid="group__group__scb__i2c__master__high__level__functions">Master High-Level</ref> and <ref kindref="compound" refid="group__group__scb__i2c__master__low__level__functions">Master Low-Level</ref>. Therefore, there are two methods for initiating I2C master transactions using either <bold>Low-Level or High-Level</bold> API. These two methods are described below. Only one method should be used at a time. <bold>They should not be mixed.</bold></para>
<para><bold>Use High-Level Functions</bold></para>
<para>Call <ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga83185adeefa83640ac09852c9d6cf426">Cy_SCB_I2C_MasterRead</ref> or <ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga91f7a32d2a20cf3deebe01cef8d9d000">Cy_SCB_I2C_MasterWrite</ref> to communicate with the slave. These functions do not block and only start a transaction. After a transaction starts, the <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref> handles further data transaction until its completion (successfully or with error occurring). To monitor the transaction, use <ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga652a3b9da6db2424fed62c28c6347ef3">Cy_SCB_I2C_MasterGetStatus</ref> or register callback function using <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1gac61f7304c304421a40135cf4d61a660c">Cy_SCB_I2C_RegisterEventCallback</ref> to be notified about <ref kindref="compound" refid="group__group__scb__i2c__macros__callback__events">I2C Callback Events</ref>.</para><para><programlisting><codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__scb__i2c__master__xfer__config__t">cy_stc_scb_i2c_master_xfer_config_t</ref><sp />transfer;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint8_t<sp />readBuffer<sp />[5UL];</highlight></codeline>
<codeline><highlight class="normal">uint8_t<sp />writeBuffer[2UL]<sp />=<sp />{0U,<sp />5U};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />write<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1ad593c8662c67ee3d7b766d1bfac64639">slaveAddress</ref><sp />=<sp />0x08U;</highlight></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a17fa9b9a817e002381f07c4982abaffa">buffer</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />writeBuffer;</highlight></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a4afeea04f622380e0c1113cc4bfbdea6">bufferSize</ref><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(writeBuffer);</highlight></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a2e158df2a2854d193d589021c2128aa4">xferPending</ref><sp /><sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;<sp /></highlight><highlight class="comment">/*<sp />Do<sp />not<sp />generate<sp />Stop<sp />condition<sp />at<sp />the<sp />end<sp />of<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initiate<sp />write<sp />transaction.</highlight></codeline>
<codeline><highlight class="comment">*<sp />The<sp />Start<sp />condition<sp />is<sp />generated<sp />to<sp />begin<sp />this<sp />transaction.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga91f7a32d2a20cf3deebe01cef8d9d000">Cy_SCB_I2C_MasterWrite</ref>(SCB3,<sp />&amp;transfer,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Wait<sp />for<sp />transaction<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__i2c__macros__master__status_1ga412fef33336fb22c95f342ccf2485a0a">CY_SCB_I2C_MASTER_BUSY</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga652a3b9da6db2424fed62c28c6347ef3">Cy_SCB_I2C_MasterGetStatus</ref>(SCB3,<sp />&amp;i2cContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />read<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a17fa9b9a817e002381f07c4982abaffa">buffer</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />readBuffer;</highlight></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a4afeea04f622380e0c1113cc4bfbdea6">bufferSize</ref><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(readBuffer);</highlight></codeline>
<codeline><highlight class="normal">transfer.<ref kindref="member" refid="structcy__stc__scb__i2c__master__xfer__config__t_1a2e158df2a2854d193d589021c2128aa4">xferPending</ref><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;<sp /></highlight><highlight class="comment">/*<sp />Generate<sp />Stop<sp />condition<sp />the<sp />end<sp />of<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initiate<sp />read<sp />transaction.</highlight></codeline>
<codeline><highlight class="comment">*<sp />The<sp />ReStart<sp />condition<sp />is<sp />generated<sp />to<sp />begin<sp />this<sp />transaction<sp />because</highlight></codeline>
<codeline><highlight class="comment">*<sp />previous<sp />transaction<sp />was<sp />completed<sp />without<sp />Stop.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga83185adeefa83640ac09852c9d6cf426">Cy_SCB_I2C_MasterRead</ref>(SCB3,<sp />&amp;transfer,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Wait<sp />for<sp />transaction<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__i2c__macros__master__status_1ga412fef33336fb22c95f342ccf2485a0a">CY_SCB_I2C_MASTER_BUSY</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__master__high__level__functions_1ga652a3b9da6db2424fed62c28c6347ef3">Cy_SCB_I2C_MasterGetStatus</ref>(SCB3,<sp />&amp;i2cContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Process<sp />received<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para>

<para><bold>Use Low-Level Functions</bold></para>
<para>Call <ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga15fa1a79148b846fd348ce39094876f0">Cy_SCB_I2C_MasterSendStart</ref> to generate a start, send an address with the Read/Write direction bit, and receive acknowledgment. After the address is ACKed by the slave, the transaction can be continued by calling <ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga0679a2b27cf3be4d1a6cd20246688fef">Cy_SCB_I2C_MasterReadByte</ref> or <ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga7eb0684e4d362668f0637d1e82405551">Cy_SCB_I2C_MasterWriteByte</ref> depending on its direction. These functions handle one byte per call. Therefore, they should be called for each byte in the transaction. Note that for the Read transaction, the last byte must be NAKed. To complete the current transaction, call <ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga4b098cd781eaa5cd287ae33e05c86a0d">Cy_SCB_I2C_MasterSendStop</ref> or call <ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga2177b4fb74cf33e57e6fa59d04bdfa7a">Cy_SCB_I2C_MasterSendReStart</ref> to complete the current transaction and start a new one. Typically, do a restart to change the transaction direction without releasing the bus from the master control. The Low-Level functions are blocking and do not require calling <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref> inside the interrupt handler. Using these functions requires extensive knowledge of the I2C protocol to execute transactions correctly.</para><para><bold>Master Write Operation</bold> <programlisting><codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__enums_1gaf621eb0719ad9ad7178d02268575b247">cy_en_scb_i2c_status_t</ref><sp />status;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Buffer<sp />to<sp />write<sp />to<sp />the<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint8_t<sp />buffer[]<sp />=<sp />{0x55,<sp />0x44,<sp />0x33};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Wait<sp />100<sp />ms<sp />until<sp />operation<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />timeout<sp />=<sp />100UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Send<sp />Start<sp />condition,<sp />address<sp />and<sp />receive<sp />ACK/NACK<sp />response<sp />from<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga15fa1a79148b846fd348ce39094876f0">Cy_SCB_I2C_MasterSendStart</ref>(SCB3,<sp />0x08U,<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga6a168a5e662ce781920027bebbab5d8da62791e1d00155a9693ceb8310aff2fee">CY_SCB_I2C_WRITE_XFER</ref>,<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref><sp />==<sp />status)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cnt<sp />=<sp />0UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Write<sp />data<sp />into<sp />the<sp />slave<sp />from<sp />the<sp />buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Write<sp />byte<sp />and<sp />receive<sp />ACK/NACK<sp />response<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga7eb0684e4d362668f0637d1e82405551">Cy_SCB_I2C_MasterWriteByte</ref>(SCB3,<sp />buffer[cnt],<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />++cnt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">((status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)<sp />&amp;&amp;<sp />(cnt<sp />&lt;<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buffer)));</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Check<sp />status<sp />of<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />||</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247ada7da6531ad390819f7fa40f41c8c8e2">CY_SCB_I2C_MASTER_MANUAL_NAK</ref>)<sp />||</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a779a11182cb3545ae0a7a615e5f322cb">CY_SCB_I2C_MASTER_MANUAL_ADDR_NAK</ref>))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />Stop<sp />condition<sp />on<sp />the<sp />bus<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga4b098cd781eaa5cd287ae33e05c86a0d">Cy_SCB_I2C_MasterSendStop</ref>(SCB3,<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Data<sp />has<sp />been<sp />written<sp />into<sp />the<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Other<sp />statuses<sp />do<sp />not<sp />require<sp />any<sp />actions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> <bold>Master Read Operation</bold> <programlisting><codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__enums_1gaf621eb0719ad9ad7178d02268575b247">cy_en_scb_i2c_status_t</ref><sp />status;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Buffer<sp />to<sp />write<sp />to<sp />the<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint8_t<sp />buffer[5U];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Wait<sp />100<sp />ms<sp />until<sp />operation<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />timeout<sp />=<sp />100UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Send<sp />Start<sp />condition,<sp />address<sp />and<sp />receive<sp />ACK/NACK<sp />response<sp />from<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga15fa1a79148b846fd348ce39094876f0">Cy_SCB_I2C_MasterSendStart</ref>(SCB3,<sp />0x08U,<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga6a168a5e662ce781920027bebbab5d8da62791e1d00155a9693ceb8310aff2fee">CY_SCB_I2C_WRITE_XFER</ref>,<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref><sp />==<sp />status)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cnt<sp />=<sp />0UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ga4600410051f7febf79d167ffbf85d7ef">cy_en_scb_i2c_command_t</ref><sp />cmd<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga4600410051f7febf79d167ffbf85d7efadd6046656aba93adef7c4823a25081fd">CY_SCB_I2C_ACK</ref>;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />data<sp />from<sp />the<sp />slave<sp />into<sp />the<sp />buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cnt<sp />==<sp />(</highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buffer)<sp />-<sp />1UL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />last<sp />byte<sp />must<sp />be<sp />NACKed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmd<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1gga4600410051f7febf79d167ffbf85d7efa46363791a98697b7b015b3b64441bfc6">CY_SCB_I2C_NAK</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />byte<sp />and<sp />generate<sp />ACK<sp />/<sp />or<sp />prepare<sp />for<sp />NACK<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga0679a2b27cf3be4d1a6cd20246688fef">Cy_SCB_I2C_MasterReadByte</ref>(SCB3,<sp />cmd,<sp />&amp;buffer[cnt],<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />++cnt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">((status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)<sp />&amp;&amp;<sp />(cnt<sp />&lt;<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buffer)));</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Check<sp />status<sp />of<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />||</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247ada7da6531ad390819f7fa40f41c8c8e2">CY_SCB_I2C_MASTER_MANUAL_NAK</ref>)<sp />||</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a779a11182cb3545ae0a7a615e5f322cb">CY_SCB_I2C_MASTER_MANUAL_ADDR_NAK</ref>))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />Stop<sp />condition<sp />on<sp />the<sp />bus<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__scb__i2c__master__low__level__functions_1ga4b098cd781eaa5cd287ae33e05c86a0d">Cy_SCB_I2C_MasterSendStop</ref>(SCB3,<sp />timeout,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__scb__i2c__enums_1ggaf621eb0719ad9ad7178d02268575b247a80d0133e4536adccb11defa72a9aa9b0">CY_SCB_I2C_SUCCESS</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Process<sp />received<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Other<sp />statuses<sp />do<sp />not<sp />require<sp />any<sp />actions.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />The<sp />received<sp />data<sp />should<sp />dropped.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>


<para><bold>Slave Operation</bold></para>
<para>Slave operation requires the <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1ga729b2fa4de4d44ea2e8995d7ca6a0c24">Cy_SCB_I2C_Interrupt</ref> be called inside the interrupt handler. The read and write buffers must be provided for the slave to enable communication with the master. Use <ref kindref="member" refid="group__group__scb__i2c__slave__functions_1ga179b4495d7255567bb8b166e16e5a073">Cy_SCB_I2C_SlaveConfigReadBuf</ref> and <ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gaaf2d216e9cb246dd2256521cb7f50170">Cy_SCB_I2C_SlaveConfigWriteBuf</ref> for this purpose. Note that after transaction completion the buffer must be configured again. Otherwise, the same buffer is used starting from the point where the master stopped a previous transaction. For example: The read buffer is configured to be 10 bytes and the master reads 8 bytes. If the read buffer is not configured again, the next master read will start from the 9th byte. To monitor the transaction status, use <ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gab3e1c474d6a5c7c5547ea08aa5d59e22">Cy_SCB_I2C_SlaveGetStatus</ref> or use <ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1gac61f7304c304421a40135cf4d61a660c">Cy_SCB_I2C_RegisterEventCallback</ref> to register a callback function to be notified about <ref kindref="compound" refid="group__group__scb__i2c__macros__callback__events">I2C Callback Events</ref>.</para><para><bold>Get Slave Events Notification</bold> <programlisting><codeline><highlight class="comment">/*<sp />Register<sp />callback<sp />for<sp />event<sp />notification.</highlight></codeline>
<codeline><highlight class="comment">*<sp />It<sp />is<sp />better<sp />to<sp />do<sp />this<sp />during<sp />initialization<sp />before<sp />I2C<sp />is<sp />enabled.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__i2c__interrupt__functions_1gac61f7304c304421a40135cf4d61a660c">Cy_SCB_I2C_RegisterEventCallback</ref>(SCB3,<sp />I2C_SlaveEventHandler,<sp />&amp;i2cContext);</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="comment">/*<sp />Callback<sp />implementation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />I2C_SlaveEventHandler(uint32_t<sp />events)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Slave<sp />sent<sp />data<sp />to<sp />master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(events<sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__macros__callback__events_1gae44345d38014821cc5d5c918dd074324">CY_SCB_I2C_SLAVE_RD_CMPLT_EVENT</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />==<sp />(events<sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__macros__callback__events_1ga88e999437b51f24bdaf50c6dac83d81c">CY_SCB_I2C_SLAVE_ERR_EVENT</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />complete<sp />without<sp />errors:<sp />update<sp />buffer<sp />content<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />read<sp />buffer<sp />for<sp />the<sp />next<sp />read<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1ga179b4495d7255567bb8b166e16e5a073">Cy_SCB_I2C_SlaveConfigReadBuf</ref>(SCB3,<sp />i2cReadBuffer,<sp /><sp />BUFFER_SIZE,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Slave<sp />received<sp />data<sp />from<sp />master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(events<sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__macros__callback__events_1gaa509ff3cd20d1b1d31e3c22e7c28871f">CY_SCB_I2C_SLAVE_WR_CMPLT_EVENT</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />==<sp />(events<sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__macros__callback__events_1ga88e999437b51f24bdaf50c6dac83d81c">CY_SCB_I2C_SLAVE_ERR_EVENT</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Write<sp />complete<sp />without<sp />errors:<sp />process<sp />received<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />buffer<sp />for<sp />the<sp />next<sp />write<sp />transaction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gaaf2d216e9cb246dd2256521cb7f50170">Cy_SCB_I2C_SlaveConfigWriteBuf</ref>(SCB3,<sp />i2cWriteBuffer,<sp />BUFFER_SIZE,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ignore<sp />all<sp />other<sp />events<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> <bold>Polling Slave Completion Events</bold> <programlisting><codeline><highlight class="comment">/*<sp />Disable<sp />I2C<sp />Interrupt:<sp />protect<sp />code<sp />from<sp />interruption<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">NVIC_DisableIRQ(I2C_INTR_NUM);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Check<sp />if<sp />write<sp />transaction<sp />completed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__i2c__macros__slave__status_1ga0e917e7b1f8b297bb97716a0a742a14a">CY_SCB_I2C_SLAVE_WR_CMPLT</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gab3e1c474d6a5c7c5547ea08aa5d59e22">Cy_SCB_I2C_SlaveGetStatus</ref>(SCB3,<sp />&amp;i2cContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Process<sp />received<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />buffer<sp />for<sp />the<sp />next<sp />write<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1gaaf2d216e9cb246dd2256521cb7f50170">Cy_SCB_I2C_SlaveConfigWriteBuf</ref>(SCB3,<sp />i2cWriteBuffer,<sp />BUFFER_SIZE,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />slave<sp />write<sp />status<sp />to<sp />capture<sp />following<sp />updates<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__i2c__slave__functions_1ga73636c22f0db8c09d790f387aa35e6be">Cy_SCB_I2C_SlaveClearWriteStatus</ref>(SCB3,<sp />&amp;i2cContext);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />I2C<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ(I2C_INTR_NUM);</highlight></codeline>
</programlisting> <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;All slave API (except &lt;a href="group__group__scb__i2c__slave__functions.html#group__group__scb__i2c__slave__functions_1ga1c9f6c807f4758016bf90cc8f69f96b3"&gt;Cy_SCB_I2C_SlaveAbortRead&lt;/a&gt; and &lt;a href="group__group__scb__i2c__slave__functions.html#group__group__scb__i2c__slave__functions_1ga50157a71ba992433bd4fde948d25d44e"&gt;Cy_SCB_I2C_SlaveAbortWrite&lt;/a&gt;) &lt;b&gt;are not interrupt-protected&lt;/b&gt; and to prevent a race condition, they should be protected from the I2C interruption in the place where they are called. The code snippet Polling Slave Completion Events above shows how to prevent a race condition when detect transfer completion and update I2C slave write buffer. The simple example of race condition is: application updates slave read buffer the I2C master starts read transfer. The I2C interrupts read buffer update and I2C interrupt loads current read buffer content in the TX FIFO . After I2C interrupt returns the application updates remaining part of the read buffer. As a result the mater read partly updated buffer.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>


<para><heading level="1">Low Power Support</heading></para>
<para>The I2C driver provides callback functions to handle power mode transition. The callback <ref kindref="member" refid="group__group__scb__i2c__low__power__functions_1gaf2044790a92ba63cb11616f2e80d3d1f">Cy_SCB_I2C_DeepSleepCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1ga5150c28fe4d2626720c1fbf74b3111ca">Cy_SysPm_CpuEnterDeepSleep</ref> <ref kindref="member" refid="group__group__scb__i2c__low__power__functions_1gaf480cdce47050c37a3558285d6a1c2a7">Cy_SCB_I2C_HibernateCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1gae97647a28c370674ba57d451d21d1c51">Cy_SysPm_SystemEnterHibernate</ref>. To trigger the callback execution, the callback must be registered before calling the power mode transition function. Refer to <ref kindref="compound" refid="group__group__syspm">SysPm (System Power Management)</ref> driver for more information about power mode transitions and callback registration.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Only applicable for &lt;b&gt;rev-08 of the CY8CKIT-062-BLE&lt;/b&gt;. For proper operation, when the I2C slave is configured to be a wakeup source from Deep Sleep mode, the &lt;a href="group__group__scb__i2c__low__power__functions.html#group__group__scb__i2c__low__power__functions_1gaf2044790a92ba63cb11616f2e80d3d1f"&gt;Cy_SCB_I2C_DeepSleepCallback&lt;/a&gt; must be copied and modified. Refer to the function description to get the details. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>